# Un clasificador con frontera no lineal
# hecho con redes de perceptrones
# 14.03.2022
# Fraga
import numpy as np
import torch
import torch.nn as nn
import torch.optim as optim
import matplotlib.pyplot as plt

# Leo los datos de entrada del archivo "circulos.csv"
D = np.loadtxt( "banMinMax.csv", delimiter=',' )
X = D[:,0:2]
y = D[:,2] - 1
print( X.shape )
print( y.shape )

# Separamos los datos de entrenamiento y de prueba
# Xentrena, Xprueba, yentrena, yprueba = model_selection.train_test_split( X, y, random_state = 17 )

X = torch.tensor(X, dtype=torch.float32)
y = torch.tensor(y, dtype=torch.float32).reshape(-1, 1)

class BananaClassifier(nn.Module):
	def __init__(self):
		super().__init__()
		self.hidden1 = nn.Linear(2, 7)
		self.act1 = nn.ReLU()
		self.hidden2 = nn.Linear(7, 7)
		self.act2 = nn.ReLU()
		self.output = nn.Linear(7, 1)
		self.act_output = nn.Sigmoid()
 
	def forward(self, x):
		x = self.act1(self.hidden1(x))
		x = self.act2(self.hidden2(x))
		x = self.act_output(self.output(x))
		return x
 
model = BananaClassifier()
print(model)

loss_fn = nn.BCELoss()  # binary cross entropy
optimizer = optim.Adam(model.parameters(), lr=0.001)

n_epochs = 100
batch_size = 10
 
for epoch in range(n_epochs):
	for i in range(0, len(X), batch_size):
		Xbatch = X[i:i+batch_size]
		y_pred = model(Xbatch)
		ybatch = y[i:i+batch_size]
		loss = loss_fn(y_pred, ybatch)
		optimizer.zero_grad()
		loss.backward()
		optimizer.step()
	print(f'Finished epoch {epoch}, latest loss {loss}')

# compute accuracy (no_grad is optional)
with torch.no_grad():
	y_pred = model(X)
 
accuracy = (y_pred.round() == y).float().mean()
print( "Accuracy:",  accuracy )

torch.save( model, "red.pt" )
